

#include "PWM.h"


void Init_PWM ( void )
{
	GPIO_InitTypeDef GPIO_InitStructure_B;
	GPIO_StructInit( &GPIO_InitStructure_B );

	// IOs als Ausgang initialisieren (PortB)
	RCC_AHBPeriphClockCmd( RCC_AHBPeriph_GPIOB, ENABLE );

	/////////////////////////////////////////////////////////
	GPIO_InitStructure_B.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure_B.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure_B.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure_B.GPIO_PuPd =  GPIO_PuPd_DOWN;
	GPIO_InitStructure_B.GPIO_Speed = GPIO_Speed_Level_3;
	GPIO_Init( GPIOB, &GPIO_InitStructure_B );

	GPIO_PinAFConfig( GPIOB, GPIO_PinSource0, GPIO_AF_2 );

	/////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////
	// Timer
	TIM_TimeBaseInitTypeDef TIM_TimeBase_InitStructure;
	TIM_TimeBaseStructInit(&TIM_TimeBase_InitStructure);
	RCC_APB2PeriphClockCmd( RCC_APB2Periph_TIM1, ENABLE );

	TIM_TimeBase_InitStructure.TIM_Prescaler = 0;
	TIM_TimeBase_InitStructure.TIM_CounterMode = TIM_CounterMode_CenterAligned1;
	TIM_TimeBase_InitStructure.TIM_Period = PWM_PERIOD;
	TIM_TimeBase_InitStructure.TIM_ClockDivision = 0;
	TIM_TimeBase_InitStructure.TIM_RepetitionCounter = 1;
	TIM_TimeBaseInit( TIM1, &TIM_TimeBase_InitStructure );

	TIM_UpdateRequestConfig( TIM1, TIM_UpdateSource_Global );
	TIM_SelectOutputTrigger( TIM1,TIM_TRGOSource_Update );
	TIM_UpdateDisableConfig( TIM1,DISABLE );


	/////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////
	// PWM
	TIM_OCInitTypeDef TIM_OCInitStructure;
	TIM_OCStructInit( &TIM_OCInitStructure );
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Enable;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;
	TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_Low;
	TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset;
	TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;
	TIM_OCInitStructure.TIM_Pulse = 0;

	TIM_OC2Init( TIM1, &TIM_OCInitStructure );
	TIM_OC2PreloadConfig( TIM1,TIM_OCPreload_Enable );
	TIM_ARRPreloadConfig( TIM1, ENABLE );

	TIM_CtrlPWMOutputs( TIM1, ENABLE );
	// Set Duty
	TIM_SetCompare2( TIM1, PWM_PERIOD / 4 );

	/* Enable Timer */
	TIM_Cmd( TIM1, ENABLE );
}
