

#include "main.h"
#include "Systick.h"
#include "Heartbeat.h"
#include "PWM.h"
#include "Regler.h"


static volatile uint32_t MSDelayCounter;

/* Timerinitialisierung */
void Init_SysTimer ( uint32_t Timerfrequenz )
{
	SysTick_Config( SystemCoreClock / Timerfrequenz );
}

/* Delayroutine for ms */
void MyDelayMS( uint32_t DelayInMS )
{
	MSDelayCounter = DelayInMS * SYSTICK_IN_HZ / 1000;
	while ( MSDelayCounter );
}

/* Delayroutine for us */
void MyDelayUS( uint32_t DelayInUS )
{
	volatile uint32_t USDelayCounter = ( DelayInUS * 391 ) / 100;
	while ( USDelayCounter ){ USDelayCounter--; }
}

// Interrupts @ 1KHz
void SysTick_Handler(void)
{
	static uint32_t Count = 0;
	static uint16_t Debounce = 0;
	Count++;

	/* Wartezeit verstreichen lassen */
	if ( MSDelayCounter ) MSDelayCounter--;
	if ( Debounce ) Debounce--;
	if ( Flags.Overcurrent ) Flags.Overcurrent--;
	if ( Flags.ForcecommutationTimer ) Flags.ForcecommutationTimer--;

	/* RS-232 */
	if ( Count % 512 == 0 ) Flags.UsartDataOut = ON;

	// Button
	if ( !(GPIOB->IDR & GPIO_Pin_7) && !Debounce ){
		Debounce = DEBOUNCETIME;
		Motorstate ^= 1;
	}

	/* Status LED */
	if ( Motorstate == OFF ) Heartbeat( DEAD );
	else if( Flags.Overcurrent || Flags.Voltagerange ) Heartbeat( ILL );
	else Heartbeat( HEALTHY );

	rpm_soll = 500 + (((uint32_t)DataBuffer[RPM_SOLL_RAW] * 2875) / 1024);

	if ( Count % 16 == 0 ){
		if ( Motorstate == ON && !Flags.Overcurrent ){
			TIM1->CCR2 = Regler (rpm_soll, rpm);
		}else{
			Clear_Integral();
			TIM1->CCR2 = PWM_PERIOD / 4;
		}
	}

}
