

#include <inttypes.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <stm32f0xx.h>

#define nop						 __asm volatile("nop");

#define L1_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_8; GPIOA->ODR |= GPIO_Pin_10 | GPIO_Pin_12;
#define L2_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_10; GPIOA->ODR |= GPIO_Pin_8 | GPIO_Pin_12 ;
#define L3_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_12; GPIOA->ODR |= GPIO_Pin_8 | GPIO_Pin_10 ;
#define POWERSTAGE_OFF()		 GPIOA->ODR &= ~ (GPIO_Pin_8 | GPIO_Pin_10 | GPIO_Pin_12);

#define L1_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_9)
#define L2_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_11)
#define L3_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_15)

#define L1_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_9)
#define L2_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_11)
#define L3_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_15)




enum{
	RPM_SOLL_RAW = 0,
	BEMF1 ,
	BEMF3 ,
	BEMF2 ,
	U_DC ,
	I_DC
};

enum{
	CURRENTLIMITTIME = 100,
	FORCECOMMUTATIONTIME = 100,
	CURRENTLIMIT = 4000,
	UNDERVOLTAGE = 3000,
	OVERVOLTAGE = 4050,
	ON = 1,
	OFF = 0,
	SYSTICK_IN_HZ = 1000,
	BAUDRATE = 9600,
	LOCKTIME = 50,
	NR_OF_VALUES = 6,
	DEBOUNCETIME = 500,
	NR_OF_RPM_MIDDLE = 64,
	SET_THRESHOLD = 2450
};

struct Flags_s{
	uint8_t UsartDataOut;
	uint16_t Overcurrent;
	uint16_t Voltagerange;
	uint16_t ForcecommutationTimer;
};



extern volatile uint16_t DataBuffer[NR_OF_VALUES];
extern volatile struct Flags_s Flags;
extern volatile uint16_t Motorstate;
extern volatile uint8_t CommutationVektor;
extern volatile uint32_t Fluxintegral;
extern volatile uint16_t FluxThreshold;
extern volatile uint16_t rpm;
extern volatile uint16_t rpm_soll;
